unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Grids, DBGrids, DBNGrid, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    DBNGrid1: TDBNGrid;
    DataSource1: TDataSource;
    Table1: TTable;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Table1EmpNo: TIntegerField;
    Table1LastName: TStringField;
    Table1FirstName: TStringField;
    Table1HireDate: TDateTimeField;
    Table1Salary: TFloatField;
    procedure DBNGrid1DrawColorDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; var GridCanvas: TCanvas; State: TGridDrawState);
    procedure DBNGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DBNGrid1CaptionClick(aCaption: Integer);
    procedure DBNGrid1SelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DBNGrid1DrawColorDataCell(Sender: TObject;
  const Rect: TRect; Field: TField; var GridCanvas: TCanvas;
  State: TGridDrawState);

var tAlign : Word;
    pText  : PChar;

begin

  case Field.AlignMent of
    taLeftJustify:  tAlign := DT_LEFT;
    taRightJustify: tAlign := DT_RIGHT;
    taCenter:       tAlign := DT_CENTER;
  end;


  GetMem( pText, 255 );
  StrPCopy( pText,Field.DisplayText );


  { -- Clearing Grid Cell -- }
  GridCanvas.Fillrect(Rect);


  GridCanvas.Font.Color := clRed;
  DrawText(GridCanvas.Handle, pText, Length(Field.DisplayText), Rect, DT_LEFT);

  FreeMem( pText, 255 );

end;

procedure TForm1.DBNGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Label1.Caption := 'Mouse X='+IntToStr(x);
  Label2.Caption := 'Mouse Y='+IntToStr(y);
end;

procedure TForm1.DBNGrid1CaptionClick(aCaption: Integer);
begin
  Label3.Caption := 'Last Selected Column is '+Dbngrid1.Fields[aCaption].DisplayLabel; 
end;

procedure TForm1.DBNGrid1SelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  Label4.Caption := 'Selected Column='+IntToStr(Col);
  Label5.Caption := 'Selected Row='+IntToStr(Row);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  DBNGrid1.ScrollBars := ssNone;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  DBNGrid1.ScrollBars := ssBoth;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  DBNGrid1.ScrollBars := ssVertical;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  DBNGrid1.ScrollBars := ssHorizontal;
end;

end.
